/* gstreamer-sdp-0.10.vapi generated by lt-vapigen, do not modify. */

[CCode (cprefix = "Gst", lower_case_cprefix = "gst_")]
namespace Gst {
	[CCode (cprefix = "GST_SDP_", has_type_id = "0", cheader_filename = "gst/sdp/gstsdp.h")]
	public enum SDPResult {
		OK,
		EINVAL
	}
	[Compact]
	[CCode (cheader_filename = "gst/sdp/gstsdpmessage.h")]
	public class SDPAttribute {
		public weak string key;
		public weak string value;
	}
	[Compact]
	[CCode (cheader_filename = "gst/sdp/gstsdpmessage.h")]
	public class SDPBandwidth {
		public weak string bwtype;
		public uint bandwidth;
	}
	[Compact]
	[CCode (cheader_filename = "gst/sdp/gstsdpmessage.h")]
	public class SDPConnection {
		public weak string nettype;
		public weak string addrtype;
		public weak string address;
		public uint ttl;
		public uint addr_number;
	}
	[Compact]
	[CCode (cheader_filename = "gst/sdp/gstsdpmessage.h")]
	public class SDPKey {
		public weak string type;
		public weak string data;
	}
	[Compact]
	[CCode (cheader_filename = "gst/sdp/gstsdpmessage.h")]
	public class SDPMedia {
		public weak string media;
		public uint port;
		public uint num_ports;
		public weak string proto;
		public weak GLib.Array fmts;
		public weak string information;
		public weak GLib.Array connections;
		public weak GLib.Array bandwidths;
		public weak Gst.SDPKey key;
		public weak GLib.Array attributes;
		public Gst.SDPResult add_attribute (string key, string value);
		public Gst.SDPResult add_bandwidth (string bwtype, uint bandwidth);
		public Gst.SDPResult add_connection (string nettype, string addrtype, string address, uint ttl, uint addr_number);
		public Gst.SDPResult add_format (string format);
		public weak string as_text ();
		public uint attributes_len ();
		public uint bandwidths_len ();
		public uint connections_len ();
		public uint formats_len ();
		public weak Gst.SDPAttribute get_attribute (uint idx);
		public weak string get_attribute_val (string key);
		public weak string get_attribute_val_n (string key, uint nth);
		public weak Gst.SDPBandwidth get_bandwidth (uint idx);
		public weak Gst.SDPConnection get_connection (uint idx);
		public weak string get_format (uint idx);
		public weak string get_information ();
		public weak Gst.SDPKey get_key ();
		public weak string get_media ();
		public uint get_num_ports ();
		public uint get_port ();
		public weak string get_proto ();
		public Gst.SDPResult init ();
		public SDPMedia (out weak Gst.SDPMedia media);
		public Gst.SDPResult set_information (string information);
		public Gst.SDPResult set_key (string type, string data);
		public Gst.SDPResult set_media (string med);
		public Gst.SDPResult set_port_info (uint port, uint num_ports);
		public Gst.SDPResult set_proto (string proto);
		public Gst.SDPResult uninit ();
	}
	[Compact]
	[CCode (cheader_filename = "gst/sdp/gstsdpmessage.h")]
	public class SDPMessage {
		public weak string version;
		public weak Gst.SDPOrigin origin;
		public weak string session_name;
		public weak string information;
		public weak string uri;
		public weak GLib.Array emails;
		public weak GLib.Array phones;
		public weak Gst.SDPConnection connection;
		public weak GLib.Array bandwidths;
		public weak GLib.Array times;
		public weak GLib.Array zones;
		public weak Gst.SDPKey key;
		public weak GLib.Array attributes;
		public weak GLib.Array medias;
		public Gst.SDPResult add_attribute (string key, string value);
		public Gst.SDPResult add_bandwidth (string bwtype, uint bandwidth);
		public Gst.SDPResult add_email (string email);
		public Gst.SDPResult add_media (Gst.SDPMedia media);
		public Gst.SDPResult add_phone (string phone);
		public Gst.SDPResult add_time (string start, string stop, string repeat);
		public Gst.SDPResult add_zone (string adj_time, string typed_time);
		public weak string as_text ();
		public uint attributes_len ();
		public uint bandwidths_len ();
		public Gst.SDPResult dump ();
		public uint emails_len ();
		public weak Gst.SDPAttribute get_attribute (uint idx);
		public weak string get_attribute_val (string key);
		public weak string get_attribute_val_n (string key, uint nth);
		public weak Gst.SDPBandwidth get_bandwidth (uint idx);
		public weak Gst.SDPConnection get_connection ();
		public weak string get_email (uint idx);
		public weak string get_information ();
		public weak Gst.SDPKey get_key ();
		public weak Gst.SDPMedia get_media (uint idx);
		public weak Gst.SDPOrigin get_origin ();
		public weak string get_phone (uint idx);
		public weak string get_session_name ();
		public weak Gst.SDPTime get_time (uint idx);
		public weak string get_uri ();
		public weak string get_version ();
		public weak Gst.SDPZone get_zone (uint idx);
		public Gst.SDPResult init ();
		public uint medias_len ();
		public SDPMessage (out weak Gst.SDPMessage msg);
		public static Gst.SDPResult parse_buffer (uchar data, uint size, Gst.SDPMessage msg);
		public uint phones_len ();
		public Gst.SDPResult set_connection (string nettype, string addrtype, string address, uint ttl, uint addr_number);
		public Gst.SDPResult set_information (string information);
		public Gst.SDPResult set_key (string type, string data);
		public Gst.SDPResult set_origin (string username, string sess_id, string sess_version, string nettype, string addrtype, string addr);
		public Gst.SDPResult set_session_name (string session_name);
		public Gst.SDPResult set_uri (string uri);
		public Gst.SDPResult set_version (string version);
		public uint times_len ();
		public Gst.SDPResult uninit ();
		public uint zones_len ();
	}
	[Compact]
	[CCode (cheader_filename = "gst/sdp/gstsdpmessage.h")]
	public class SDPOrigin {
		public weak string username;
		public weak string sess_id;
		public weak string sess_version;
		public weak string nettype;
		public weak string addrtype;
		public weak string addr;
	}
	[Compact]
	[CCode (cheader_filename = "gst/sdp/gstsdpmessage.h")]
	public class SDPTime {
		public weak string start;
		public weak string stop;
		public weak GLib.Array repeat;
	}
	[Compact]
	[CCode (cheader_filename = "gst/sdp/gstsdpmessage.h")]
	public class SDPZone {
		public weak string time;
		public weak string typed_time;
	}
	[CCode (cheader_filename = "gst/sdp/gstsdpmessage.h")]
	public const string SDP_BWTYPE_AS;
	[CCode (cheader_filename = "gst/sdp/gstsdpmessage.h")]
	public const string SDP_BWTYPE_CT;
	[CCode (cheader_filename = "gst/sdp/gstsdpmessage.h")]
	public const string SDP_BWTYPE_EXT_PREFIX;
	[CCode (cheader_filename = "gst/sdp/gstsdpmessage.h")]
	public const string SDP_BWTYPE_RR;
	[CCode (cheader_filename = "gst/sdp/gstsdpmessage.h")]
	public const string SDP_BWTYPE_RS;
}
